private import filter;
private import request;
private import response;
private import typical_responses;
private import log;

private import std.string;

version (USE_YAML_RESPONSER) {
	version = USE_CONFIG_RESPONSER;
}
version (USE_RC_RESPONSER) {
	version = USE_CONFIG_RESPONSER;
}

version (USE_CONFIG_RESPONSER) {
	bool config_filter(HttpRequest req, inout HttpResponse res,
					   char[] delegate(char[]) getValue_) {
		char[] src = res.messageBody;
		char[] dst = "";

		int idx;
		while ((idx = std.string.find(src, "${")) != -1) {
			dst ~= src[0..idx];
			src = src[idx+2..src.length];

			int endidx = std.string.find(src, "}");
			if (endidx == -1) {
				Log.warn("${ is not closed");
				res = TypicalResponses.resInternalServerError;
				return false;
			}

			char[] cmd = src[0..endidx];
			src = src[endidx+1..src.length];

			char[][] ops = std.string.split(cmd, ";");
			if (ops[0] == "get") {
				if (ops.length != 2) {
					Log.warn("invalid ${get; operation");
					res =
						TypicalResponses.resInternalServerError;
					return false;
				}

				dst ~= getValue_(ops[1]);
			}
			else if (ops[0] == "if") {
				if (ops.length != 4) {
					Log.warn("invalid ${if; operation");
					res =
						TypicalResponses.resInternalServerError;
					return false;
				}

				if (getValue_(ops[1]) == ops[2]) {
					dst ~= ops[3];
				}
			}
			else {
				Log.warn(ops[0] ~ ": invalid operator");
				res = TypicalResponses.resInternalServerError;
				return false;
			}
		}
		dst ~= src;

		res.messageBody = dst;

		return true;
	}

}

