private import filter;
private import request;
private import response;
private import typical_responses;
private import log;

private import gzip;

private import std.zlib;
private import std.conv;
private import std.file;

version (USE_GZIP_FILTER) {

class GzipFilter : Filter {
	bool filter(HttpRequest req, inout HttpResponse res) {
        if (!req.requestHost) return true;

        if (!("content-encoding" in res.header)) return true;

        char[] enc = res.header["content-encoding"];
        if (enc == "gzip") {
            try {
                res.messageBody = cast(char[])gzip.uncompress(res.messageBody);

                delete res.header["content-encoding"];

                Log.info("inflated gzip");
            }
            catch (ZlibException ze) {
                Log.warn("cannot deflate zlib errored: " ~ ze.toString());
            }
            catch (Object o) {
                Log.warn("cannot deflate: " ~ o.toString());
            }
        }

        return true;
    }

}
}
