private import std.string;

/***************************************************
 * Return contents of directory.
 */

extern (C)
{
	struct DIR;

	struct Dirent
	{
		uint d_ino;
		uint d_off;
		ushort d_reclen;
		char d_type;
		char[256] d_name;	/* NAME_MAX+1 from linux/limits.h */
	};
	
	DIR* opendir(char* name);
	int closedir(DIR* dir);
	Dirent* readdir(DIR* dir);
}

char[][] listdir(char[] pathname)
{

	Dirent* entry;
	DIR* dir = opendir(toStringz(pathname));
	char[][] result;
	entry = readdir(dir);
	while ( entry !== null )
	{
		
		if ( std.string.strcmp(entry.d_name, ".") != 0
			&& std.string.strcmp(entry.d_name, "..") != 0)
		{
			result ~= std.string.toString(entry.d_name).dup;
		}
		entry = readdir(dir);
	}
	closedir(dir);
	return result;

}
