﻿version = GUI;

version(GUI){
	version(Win32){
		version = Win32_GUI;
	}
}

private import 
	std.c.stdio, std.c.stdlib,
	attohttpd;

version(Win32_GUI){
	private import
		win32.ansi.windows, std.stream, std.thread, std.utf;
}

version(Win32_GUI){

	TCHAR[] version_text = "attohttpd改";

	class Main_Thread : Thread
	{
		override int run()
		{
			return cmain();
		}
	}

	enum { WM_APP_ICON = WM_USER + 1000 }
	
	NOTIFYICONDATA icon = {
		cbSize: NOTIFYICONDATA.sizeof,
		uID: 100,
		uFlags: NIF_ICON | NIF_MESSAGE | NIF_TIP,
		uCallbackMessage: WM_APP_ICON,
		szTip: "attohttpd"
		};
	
	WNDPROC original_proc;
	
	extern(Windows) LRESULT WindowProc(HWND wnd, uint msg, WPARAM w, LPARAM l)
	{
		switch(msg){
		case WM_APP_ICON:
			if(w == 100){
				if(l == WM_RBUTTONUP){
					BOOL v = IsWindowVisible(wnd);
					if(!v){
						ShowWindow(wnd, SW_MINIMIZE);
					}
					SetForegroundWindow(wnd);
					HMENU menu = CreatePopupMenu;
					AppendMenu(menu, MF_STRING, 200, `&Show`);
					AppendMenu(menu, MF_STRING, 201, `&Hide`);
					AppendMenu(menu, MF_SEPARATOR, 0, null);
					AppendMenu(menu, MF_STRING, 400, `&Exit`);
					POINT p;
					GetCursorPos(&p);
					TrackPopupMenu(menu, TPM_RIGHTBUTTON, p.x, p.y, 0, wnd, null);
					DestroyMenu(menu);
					if(!v){
						ShowWindow(wnd, SW_HIDE);
					}
				}
			}
			return 0;
		case WM_COMMAND:
			switch(w){
			case 200:
				ShowWindow(wnd, SW_RESTORE);
				ShowWindow(wnd, SW_SHOW);
				return 0;
			case 201:
				ShowWindow(wnd, SW_HIDE);
				return 0;
			case 400:
				PostMessage(wnd, WM_CLOSE, 0, 0);
				return 0;
			default:
				;
			}
			break;
		case WM_SYSCOMMAND:
			if(w == SC_CLOSE){
				ShowWindow(wnd, SW_HIDE);
				return 0;
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
		default:
			;
		}
		return CallWindowProc(original_proc, wnd, msg, w, l);
	}
	
	class Log_Stream : File
	{
		char[] buffer;
		override void writeString(char[] s)
		{
			synchronized(this){
				buffer ~= s;
				for(;;){
					int i = find(buffer, '\n');
					if(i >= 0){
						TCHAR* s;
						try{
							int j = i;
							if(i > 0 && buffer[i - 1] == '\r'){
								--j;
							}
							s = buffer[0..j];
//							s = toUTF16z(buffer[0..j]);
						}catch{
							s = `(BIN)`\0;
						}
						SendMessage(icon.hWnd, LB_ADDSTRING, 0, cast(LPARAM)s);
						buffer = buffer[i + 1..buffer.length].dup;
						if(SendMessage(icon.hWnd, LB_GETCOUNT, 0, 0) > 1024){
							SendMessage(icon.hWnd, LB_DELETESTRING, 0, 0);
						}
					}else{
						break;
					}
				}
			}
		}
	}
	
	extern (C) void gc_init();
	extern (C) void gc_term();
	extern (C) void _minit();
	extern (C) void _moduleCtor();
	extern (C) void _moduleUnitTests();
	
	extern (Windows) int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR CmdLine, int CmdShow)
	{
		gc_init();
		_minit();
		try{
			_moduleCtor();
			_moduleUnitTests();
	
			const TCHAR* window_class_name = `attohttpd_window`\0;
			if(FindWindow(window_class_name, null) != null){
				throw new Exception(`二重起動防止`);
			}
	
			WNDCLASSEX wc;
			wc.cbSize = wc.sizeof;
			GetClassInfoEx(null, "LISTBOX", &wc);
			original_proc = wc.lpfnWndProc;
			wc.lpszClassName = window_class_name;
			wc.lpfnWndProc = &WindowProc;
			wc.hInstance = hInstance;
			wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(1));
			ATOM r = RegisterClassEx(&wc);
			assert(r);
	
			icon.hIcon = wc.hIcon;
			icon.hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, 
				window_class_name, version_text,
				WS_OVERLAPPEDWINDOW | WS_VSCROLL | WS_HSCROLL, 
				CW_USEDEFAULT, CW_USEDEFAULT, 400, 300, 
				NULL, NULL, hInstance, NULL);
	
			assert(icon.hWnd);
	
			debug{ ShowWindow(icon.hWnd, CmdShow); }
//			Shell_NotifyIcon(NIM_ADD, &icon);
			
			std.stream.stdout = new Log_Stream();
	
/+
			try{
				stderr = new File("error.log", FileMode.In | FileMode.Out);
				stderr.seek(0, SeekPos.End);
			}catch(OpenError){
				stderr = new File();
				stderr.create("error.log");
				stderr.writeString(`﻿`);
			}
+/
	
			Main_Thread thread = new Main_Thread();
			thread.start();
	
			MSG msg;
			while(GetMessage(&msg, NULL, 0, 0))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}

//			Shell_NotifyIcon(NIM_DELETE, &icon);
	
		}catch(Object e){
			MessageBoxW(null, toUTF16z(e.toString()), toUTF16z(e.classinfo.name), 0);
		}
		gc_term();
	
		return 0;
	}

}else{

	int main(char[][] args) {
		version (UNITTEST) {
			return 0;
		}
		else {
	        try {
	            //return cmain(argv[1]);
	            return cmain();
	        }
	        catch (Object o) {
	            perror("unknown exception");
	            return 1;
	        }
		}
	}

}
