private import filter;
private import request;
private import response;
private import typical_responses;
private import attohttpd;
private import log;
private import rc;
private import abstract_config_filter;

private import std.string;

version (USE_RC_RESPONSER) {

class RcFilter : Filter {
	this(char[] sep) { sep_ = sep; }

	bool filter(HttpRequest req, inout HttpResponse res) {
		if (req.localFile.length <= 8 ||
			std.string.rfind(req.localFile, ".rc.html") !=
			req.localFile.length - 8)
		{
			return true;
		}

		rcFile_ = req.localFile[0..req.localFile.length-5];
		rc_ = new Rc(sep_);
		rc_.addResourceFile(rcFile_);

		return config_filter(req, res, &getValue_);
	}

protected:
	char[] getValue_(char[] key) {
		char[] val = rc_.get(key);
		if (val === null) {
			Log.warn(rcFile_ ~ ": " ~ key ~ " not found");
			return "";
		}
		else {
			return val;
		}
	}

private:
	char[] rcFile_;
	Rc rc_;
	char[] sep_;

}

}
