private import filter;
private import request;
private import response;
private import typical_responses;
private import log;
private import bogoyaml;
private import ypath;
private import abstract_config_filter;

private import std.string;

version (USE_YAML_RESPONSER) {

class YamlFilter : Filter {
	bool filter(HttpRequest req, inout HttpResponse res) {
		if (req.localFile.length <= 9 ||
			std.string.rfind(req.localFile, ".yml.html") !=
			req.localFile.length - 9)
		{
			return true;
		}

		yamlFile_ = req.localFile[0..req.localFile.length-5];
		yaml_ = bogoyaml.yamlLoad(yamlFile_);

		return config_filter(req, res, &getValue_);
	}

protected:
	char[] getValue_(char[] key) {
		try {
			YamlHolder y = getYpath(yaml_, key);
			return y.str();
		}
		catch (YamlError ye) {
			Log.warn(yamlFile_ ~ ": " ~ key ~ " not found");
		}
		return "";
	}

private:
	char[] yamlFile_;
	YamlHolder yaml_;


}

}
